import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type AuthConfigStruct = {
    owner: PromiseOrValue<string>;
    guardian: PromiseOrValue<string>;
    manager: PromiseOrValue<string>;
};
export type AuthConfigStructOutput = [string, string, string] & {
    owner: string;
    guardian: string;
    manager: string;
};
export type IMXConfigStruct = {
    vault: PromiseOrValue<string>;
    underlying: PromiseOrValue<string>;
    short: PromiseOrValue<string>;
    uniPair: PromiseOrValue<string>;
    poolToken: PromiseOrValue<string>;
    farmToken: PromiseOrValue<string>;
    farmRouter: PromiseOrValue<string>;
};
export type IMXConfigStructOutput = [
    string,
    string,
    string,
    string,
    string,
    string,
    string
] & {
    vault: string;
    underlying: string;
    short: string;
    uniPair: string;
    poolToken: string;
    farmToken: string;
    farmRouter: string;
};
export type EActionStruct = {
    target: PromiseOrValue<string>;
    value: PromiseOrValue<BigNumberish>;
    data: PromiseOrValue<BytesLike>;
};
export type EActionStructOutput = [string, BigNumber, string] & {
    target: string;
    value: BigNumber;
    data: string;
};
export type HarvestSwapParamsStruct = {
    path: PromiseOrValue<string>[];
    min: PromiseOrValue<BigNumberish>;
    deadline: PromiseOrValue<BigNumberish>;
    pathData: PromiseOrValue<BytesLike>;
};
export type HarvestSwapParamsStructOutput = [
    string[],
    BigNumber,
    BigNumber,
    string
] & {
    path: string[];
    min: BigNumber;
    deadline: BigNumber;
    pathData: string;
};
export interface IMXInterface extends utils.Interface {
    functions: {
        "DEFAULT_ADMIN_ROLE()": FunctionFragment;
        "GUARDIAN()": FunctionFragment;
        "MANAGER()": FunctionFragment;
        "_pair()": FunctionFragment;
        "acceptOwnership()": FunctionFragment;
        "accrueInterest()": FunctionFragment;
        "callLoanHealth()": FunctionFragment;
        "closePosition(uint256)": FunctionFragment;
        "collateralToUnderlying()": FunctionFragment;
        "collateralToken()": FunctionFragment;
        "decimals()": FunctionFragment;
        "deposit(uint256)": FunctionFragment;
        "emergencyAction((address,uint256,bytes)[])": FunctionFragment;
        "farmRouter()": FunctionFragment;
        "flip()": FunctionFragment;
        "getAndUpdateTvl()": FunctionFragment;
        "getDepositAmnt(uint256)": FunctionFragment;
        "getExpectedPrice()": FunctionFragment;
        "getLPBalances()": FunctionFragment;
        "getLiquidity()": FunctionFragment;
        "getLpBalance()": FunctionFragment;
        "getLpToken()": FunctionFragment;
        "getMaxTvl()": FunctionFragment;
        "getPositionOffset()": FunctionFragment;
        "getRoleAdmin(bytes32)": FunctionFragment;
        "getTVL()": FunctionFragment;
        "getTotalTVL()": FunctionFragment;
        "getTvl()": FunctionFragment;
        "getUnderlyingShortReserves()": FunctionFragment;
        "getWithdrawAmnt(uint256)": FunctionFragment;
        "grantRole(bytes32,address)": FunctionFragment;
        "harvest((address[],uint256,uint256,bytes)[],(address[],uint256,uint256,bytes)[])": FunctionFragment;
        "harvestIsEnabled()": FunctionFragment;
        "hasRole(bytes32,address)": FunctionFragment;
        "impermaxBorrow(address,address,uint256,bytes)": FunctionFragment;
        "impermaxChef()": FunctionFragment;
        "impermaxRedeem(address,uint256,bytes)": FunctionFragment;
        "loanHealth()": FunctionFragment;
        "maxPriceOffset()": FunctionFragment;
        "owner()": FunctionFragment;
        "pair()": FunctionFragment;
        "pendingHarvest()": FunctionFragment;
        "pendingOwner()": FunctionFragment;
        "rebalance(uint256,uint256)": FunctionFragment;
        "rebalanceThreshold()": FunctionFragment;
        "redeem(address,uint256)": FunctionFragment;
        "renounceRole(bytes32,address)": FunctionFragment;
        "revokeRole(bytes32,address)": FunctionFragment;
        "sBorrowable()": FunctionFragment;
        "safetyMarginSqrt()": FunctionFragment;
        "setMaxPriceOffset(uint256)": FunctionFragment;
        "setRebalanceThreshold(uint16)": FunctionFragment;
        "setSafetyMarginSqrt(uint256)": FunctionFragment;
        "short()": FunctionFragment;
        "shortToUnderlyingOracle(uint256)": FunctionFragment;
        "shortToUnderlyingOracleUpdate(uint256)": FunctionFragment;
        "supportsInterface(bytes4)": FunctionFragment;
        "tarotBorrow(address,address,uint256,bytes)": FunctionFragment;
        "tarotRedeem(address,uint256,bytes)": FunctionFragment;
        "transferOwnership(address)": FunctionFragment;
        "uBorrowable()": FunctionFragment;
        "underlying()": FunctionFragment;
        "updateOracle()": FunctionFragment;
        "vault()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "DEFAULT_ADMIN_ROLE" | "GUARDIAN" | "MANAGER" | "_pair" | "acceptOwnership" | "accrueInterest" | "callLoanHealth" | "closePosition" | "collateralToUnderlying" | "collateralToken" | "decimals" | "deposit" | "emergencyAction" | "farmRouter" | "flip" | "getAndUpdateTvl" | "getDepositAmnt" | "getExpectedPrice" | "getLPBalances" | "getLiquidity" | "getLpBalance" | "getLpToken" | "getMaxTvl" | "getPositionOffset" | "getRoleAdmin" | "getTVL" | "getTotalTVL" | "getTvl" | "getUnderlyingShortReserves" | "getWithdrawAmnt" | "grantRole" | "harvest" | "harvestIsEnabled" | "hasRole" | "impermaxBorrow" | "impermaxChef" | "impermaxRedeem" | "loanHealth" | "maxPriceOffset" | "owner" | "pair" | "pendingHarvest" | "pendingOwner" | "rebalance" | "rebalanceThreshold" | "redeem" | "renounceRole" | "revokeRole" | "sBorrowable" | "safetyMarginSqrt" | "setMaxPriceOffset" | "setRebalanceThreshold" | "setSafetyMarginSqrt" | "short" | "shortToUnderlyingOracle" | "shortToUnderlyingOracleUpdate" | "supportsInterface" | "tarotBorrow" | "tarotRedeem" | "transferOwnership" | "uBorrowable" | "underlying" | "updateOracle" | "vault"): FunctionFragment;
    encodeFunctionData(functionFragment: "DEFAULT_ADMIN_ROLE", values?: undefined): string;
    encodeFunctionData(functionFragment: "GUARDIAN", values?: undefined): string;
    encodeFunctionData(functionFragment: "MANAGER", values?: undefined): string;
    encodeFunctionData(functionFragment: "_pair", values?: undefined): string;
    encodeFunctionData(functionFragment: "acceptOwnership", values?: undefined): string;
    encodeFunctionData(functionFragment: "accrueInterest", values?: undefined): string;
    encodeFunctionData(functionFragment: "callLoanHealth", values?: undefined): string;
    encodeFunctionData(functionFragment: "closePosition", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "collateralToUnderlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "collateralToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "decimals", values?: undefined): string;
    encodeFunctionData(functionFragment: "deposit", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "emergencyAction", values: [EActionStruct[]]): string;
    encodeFunctionData(functionFragment: "farmRouter", values?: undefined): string;
    encodeFunctionData(functionFragment: "flip", values?: undefined): string;
    encodeFunctionData(functionFragment: "getAndUpdateTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getDepositAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "getExpectedPrice", values?: undefined): string;
    encodeFunctionData(functionFragment: "getLPBalances", values?: undefined): string;
    encodeFunctionData(functionFragment: "getLiquidity", values?: undefined): string;
    encodeFunctionData(functionFragment: "getLpBalance", values?: undefined): string;
    encodeFunctionData(functionFragment: "getLpToken", values?: undefined): string;
    encodeFunctionData(functionFragment: "getMaxTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getPositionOffset", values?: undefined): string;
    encodeFunctionData(functionFragment: "getRoleAdmin", values: [PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "getTVL", values?: undefined): string;
    encodeFunctionData(functionFragment: "getTotalTVL", values?: undefined): string;
    encodeFunctionData(functionFragment: "getTvl", values?: undefined): string;
    encodeFunctionData(functionFragment: "getUnderlyingShortReserves", values?: undefined): string;
    encodeFunctionData(functionFragment: "getWithdrawAmnt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "grantRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "harvest", values: [HarvestSwapParamsStruct[], HarvestSwapParamsStruct[]]): string;
    encodeFunctionData(functionFragment: "harvestIsEnabled", values?: undefined): string;
    encodeFunctionData(functionFragment: "hasRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "impermaxBorrow", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "impermaxChef", values?: undefined): string;
    encodeFunctionData(functionFragment: "impermaxRedeem", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "loanHealth", values?: undefined): string;
    encodeFunctionData(functionFragment: "maxPriceOffset", values?: undefined): string;
    encodeFunctionData(functionFragment: "owner", values?: undefined): string;
    encodeFunctionData(functionFragment: "pair", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingHarvest", values?: undefined): string;
    encodeFunctionData(functionFragment: "pendingOwner", values?: undefined): string;
    encodeFunctionData(functionFragment: "rebalance", values: [PromiseOrValue<BigNumberish>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "rebalanceThreshold", values?: undefined): string;
    encodeFunctionData(functionFragment: "redeem", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "renounceRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "revokeRole", values: [PromiseOrValue<BytesLike>, PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "sBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "safetyMarginSqrt", values?: undefined): string;
    encodeFunctionData(functionFragment: "setMaxPriceOffset", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setRebalanceThreshold", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "setSafetyMarginSqrt", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "short", values?: undefined): string;
    encodeFunctionData(functionFragment: "shortToUnderlyingOracle", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "shortToUnderlyingOracleUpdate", values: [PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "supportsInterface", values: [PromiseOrValue<BytesLike>]): string;
    encodeFunctionData(functionFragment: "tarotBorrow", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "tarotRedeem", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "transferOwnership", values: [PromiseOrValue<string>]): string;
    encodeFunctionData(functionFragment: "uBorrowable", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "updateOracle", values?: undefined): string;
    encodeFunctionData(functionFragment: "vault", values?: undefined): string;
    decodeFunctionResult(functionFragment: "DEFAULT_ADMIN_ROLE", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "GUARDIAN", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "MANAGER", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "_pair", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "acceptOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "accrueInterest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "callLoanHealth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "closePosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralToUnderlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "collateralToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "decimals", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "deposit", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "emergencyAction", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "farmRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "flip", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getAndUpdateTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getDepositAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getExpectedPrice", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLPBalances", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLiquidity", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLpBalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getLpToken", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getMaxTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getPositionOffset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getRoleAdmin", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTVL", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTotalTVL", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getTvl", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingShortReserves", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getWithdrawAmnt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "grantRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "harvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "harvestIsEnabled", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "hasRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxBorrow", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxChef", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "impermaxRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "loanHealth", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "maxPriceOffset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "owner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pair", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingHarvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pendingOwner", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "rebalance", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "rebalanceThreshold", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "redeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "renounceRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "revokeRole", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "sBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "safetyMarginSqrt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setMaxPriceOffset", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRebalanceThreshold", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setSafetyMarginSqrt", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "short", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "shortToUnderlyingOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "shortToUnderlyingOracleUpdate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "supportsInterface", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tarotBorrow", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "tarotRedeem", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "transferOwnership", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "uBorrowable", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "updateOracle", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "vault", data: BytesLike): Result;
    events: {
        "Deposit(address,uint256)": EventFragment;
        "EmergencyAction(address,bytes)": EventFragment;
        "Harvest(uint256)": EventFragment;
        "HarvestedToken(address,uint256)": EventFragment;
        "OwnershipTransferInitiated(address,address)": EventFragment;
        "OwnershipTransferred(address,address)": EventFragment;
        "Rebalance(uint256,uint256,uint256)": EventFragment;
        "Redeem(address,uint256)": EventFragment;
        "RoleAdminChanged(bytes32,bytes32,bytes32)": EventFragment;
        "RoleGranted(bytes32,address,address)": EventFragment;
        "RoleRevoked(bytes32,address,address)": EventFragment;
        "SetMaxPriceOffset(uint256)": EventFragment;
        "SetRebalanceThreshold(uint256)": EventFragment;
        "SetSafetyMarginSqrt(uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "Deposit"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "EmergencyAction"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Harvest"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferInitiated"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "OwnershipTransferred"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Rebalance"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "Redeem"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleAdminChanged"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleGranted"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "RoleRevoked"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetMaxPriceOffset"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetRebalanceThreshold"): EventFragment;
    getEvent(nameOrSignatureOrTopic: "SetSafetyMarginSqrt"): EventFragment;
}
export interface DepositEventObject {
    sender: string;
    amount: BigNumber;
}
export type DepositEvent = TypedEvent<[string, BigNumber], DepositEventObject>;
export type DepositEventFilter = TypedEventFilter<DepositEvent>;
export interface EmergencyActionEventObject {
    target: string;
    data: string;
}
export type EmergencyActionEvent = TypedEvent<[
    string,
    string
], EmergencyActionEventObject>;
export type EmergencyActionEventFilter = TypedEventFilter<EmergencyActionEvent>;
export interface HarvestEventObject {
    harvested: BigNumber;
}
export type HarvestEvent = TypedEvent<[BigNumber], HarvestEventObject>;
export type HarvestEventFilter = TypedEventFilter<HarvestEvent>;
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface OwnershipTransferInitiatedEventObject {
    owner: string;
    pendingOwner: string;
}
export type OwnershipTransferInitiatedEvent = TypedEvent<[
    string,
    string
], OwnershipTransferInitiatedEventObject>;
export type OwnershipTransferInitiatedEventFilter = TypedEventFilter<OwnershipTransferInitiatedEvent>;
export interface OwnershipTransferredEventObject {
    oldOwner: string;
    newOwner: string;
}
export type OwnershipTransferredEvent = TypedEvent<[
    string,
    string
], OwnershipTransferredEventObject>;
export type OwnershipTransferredEventFilter = TypedEventFilter<OwnershipTransferredEvent>;
export interface RebalanceEventObject {
    shortPrice: BigNumber;
    tvlBeforeRebalance: BigNumber;
    positionOffset: BigNumber;
}
export type RebalanceEvent = TypedEvent<[
    BigNumber,
    BigNumber,
    BigNumber
], RebalanceEventObject>;
export type RebalanceEventFilter = TypedEventFilter<RebalanceEvent>;
export interface RedeemEventObject {
    sender: string;
    amount: BigNumber;
}
export type RedeemEvent = TypedEvent<[string, BigNumber], RedeemEventObject>;
export type RedeemEventFilter = TypedEventFilter<RedeemEvent>;
export interface RoleAdminChangedEventObject {
    role: string;
    previousAdminRole: string;
    newAdminRole: string;
}
export type RoleAdminChangedEvent = TypedEvent<[
    string,
    string,
    string
], RoleAdminChangedEventObject>;
export type RoleAdminChangedEventFilter = TypedEventFilter<RoleAdminChangedEvent>;
export interface RoleGrantedEventObject {
    role: string;
    account: string;
    sender: string;
}
export type RoleGrantedEvent = TypedEvent<[
    string,
    string,
    string
], RoleGrantedEventObject>;
export type RoleGrantedEventFilter = TypedEventFilter<RoleGrantedEvent>;
export interface RoleRevokedEventObject {
    role: string;
    account: string;
    sender: string;
}
export type RoleRevokedEvent = TypedEvent<[
    string,
    string,
    string
], RoleRevokedEventObject>;
export type RoleRevokedEventFilter = TypedEventFilter<RoleRevokedEvent>;
export interface SetMaxPriceOffsetEventObject {
    maxPriceOffset: BigNumber;
}
export type SetMaxPriceOffsetEvent = TypedEvent<[
    BigNumber
], SetMaxPriceOffsetEventObject>;
export type SetMaxPriceOffsetEventFilter = TypedEventFilter<SetMaxPriceOffsetEvent>;
export interface SetRebalanceThresholdEventObject {
    rebalanceThreshold: BigNumber;
}
export type SetRebalanceThresholdEvent = TypedEvent<[
    BigNumber
], SetRebalanceThresholdEventObject>;
export type SetRebalanceThresholdEventFilter = TypedEventFilter<SetRebalanceThresholdEvent>;
export interface SetSafetyMarginSqrtEventObject {
    safetyMarginSqrt: BigNumber;
}
export type SetSafetyMarginSqrtEvent = TypedEvent<[
    BigNumber
], SetSafetyMarginSqrtEventObject>;
export type SetSafetyMarginSqrtEventFilter = TypedEventFilter<SetSafetyMarginSqrtEvent>;
export interface IMX extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IMXInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<[string]>;
        GUARDIAN(overrides?: CallOverrides): Promise<[string]>;
        MANAGER(overrides?: CallOverrides): Promise<[string]>;
        _pair(overrides?: CallOverrides): Promise<[string]>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        callLoanHealth(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        closePosition(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<[BigNumber]>;
        collateralToken(overrides?: CallOverrides): Promise<[string]>;
        decimals(overrides?: CallOverrides): Promise<[number]>;
        deposit(underlyingAmnt: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        emergencyAction(actions: EActionStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        farmRouter(overrides?: CallOverrides): Promise<[string]>;
        flip(overrides?: CallOverrides): Promise<[boolean]>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        getDepositAmnt(uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        getExpectedPrice(overrides?: CallOverrides): Promise<[BigNumber]>;
        getLPBalances(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            underlyingLp: BigNumber;
            shortLp: BigNumber;
        }>;
        getLiquidity(overrides?: CallOverrides): Promise<[BigNumber]>;
        getLpBalance(overrides?: CallOverrides): Promise<[BigNumber]>;
        getLpToken(overrides?: CallOverrides): Promise<[string]>;
        getMaxTvl(overrides?: CallOverrides): Promise<[BigNumber]>;
        getPositionOffset(overrides?: CallOverrides): Promise<[BigNumber] & {
            positionOffset: BigNumber;
        }>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[string]>;
        getTVL(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            tvl: BigNumber;
            borrowPosition: BigNumber;
            borrowBalance: BigNumber;
            lpBalance: BigNumber;
            underlyingBalance: BigNumber;
        }>;
        getTotalTVL(overrides?: CallOverrides): Promise<[BigNumber] & {
            tvl: BigNumber;
        }>;
        getTvl(overrides?: CallOverrides): Promise<[BigNumber] & {
            tvl: BigNumber;
        }>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        getWithdrawAmnt(lpTokens: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        harvest(harvestParams: HarvestSwapParamsStruct[], arg1: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        harvestIsEnabled(overrides?: CallOverrides): Promise<[boolean]>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<[boolean]>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        impermaxChef(overrides?: CallOverrides): Promise<[string]>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        loanHealth(overrides?: CallOverrides): Promise<[BigNumber]>;
        maxPriceOffset(overrides?: CallOverrides): Promise<[BigNumber]>;
        owner(overrides?: CallOverrides): Promise<[string]>;
        pair(overrides?: CallOverrides): Promise<[string]>;
        pendingHarvest(overrides?: CallOverrides): Promise<[BigNumber] & {
            harvested: BigNumber;
        }>;
        pendingOwner(overrides?: CallOverrides): Promise<[string]>;
        rebalance(expectedPrice: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        rebalanceThreshold(overrides?: CallOverrides): Promise<[number]>;
        redeem(recipient: PromiseOrValue<string>, removeCollateral: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        sBorrowable(overrides?: CallOverrides): Promise<[string]>;
        safetyMarginSqrt(overrides?: CallOverrides): Promise<[BigNumber]>;
        setMaxPriceOffset(_maxPriceOffset: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setRebalanceThreshold(rebalanceThreshold_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setSafetyMarginSqrt(safetyMarginSqrt_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        short(overrides?: CallOverrides): Promise<[string]>;
        shortToUnderlyingOracle(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<[BigNumber]>;
        shortToUnderlyingOracleUpdate(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<[boolean]>;
        tarotBorrow(a: PromiseOrValue<string>, b: PromiseOrValue<string>, c: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        tarotRedeem(a: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        uBorrowable(overrides?: CallOverrides): Promise<[string]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
        updateOracle(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        vault(overrides?: CallOverrides): Promise<[string]>;
    };
    DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;
    GUARDIAN(overrides?: CallOverrides): Promise<string>;
    MANAGER(overrides?: CallOverrides): Promise<string>;
    _pair(overrides?: CallOverrides): Promise<string>;
    acceptOwnership(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    accrueInterest(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callLoanHealth(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    closePosition(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
    collateralToken(overrides?: CallOverrides): Promise<string>;
    decimals(overrides?: CallOverrides): Promise<number>;
    deposit(underlyingAmnt: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    emergencyAction(actions: EActionStruct[], overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    farmRouter(overrides?: CallOverrides): Promise<string>;
    flip(overrides?: CallOverrides): Promise<boolean>;
    getAndUpdateTvl(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    getDepositAmnt(uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    getExpectedPrice(overrides?: CallOverrides): Promise<BigNumber>;
    getLPBalances(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        underlyingLp: BigNumber;
        shortLp: BigNumber;
    }>;
    getLiquidity(overrides?: CallOverrides): Promise<BigNumber>;
    getLpBalance(overrides?: CallOverrides): Promise<BigNumber>;
    getLpToken(overrides?: CallOverrides): Promise<string>;
    getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getPositionOffset(overrides?: CallOverrides): Promise<BigNumber>;
    getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
    getTVL(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber,
        BigNumber
    ] & {
        tvl: BigNumber;
        borrowPosition: BigNumber;
        borrowBalance: BigNumber;
        lpBalance: BigNumber;
        underlyingBalance: BigNumber;
    }>;
    getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
    getTvl(overrides?: CallOverrides): Promise<BigNumber>;
    getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
    }>;
    getWithdrawAmnt(lpTokens: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    harvest(harvestParams: HarvestSwapParamsStruct[], arg1: HarvestSwapParamsStruct[], overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    harvestIsEnabled(overrides?: CallOverrides): Promise<boolean>;
    hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
    impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    impermaxChef(overrides?: CallOverrides): Promise<string>;
    impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
    maxPriceOffset(overrides?: CallOverrides): Promise<BigNumber>;
    owner(overrides?: CallOverrides): Promise<string>;
    pair(overrides?: CallOverrides): Promise<string>;
    pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
    pendingOwner(overrides?: CallOverrides): Promise<string>;
    rebalance(expectedPrice: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    rebalanceThreshold(overrides?: CallOverrides): Promise<number>;
    redeem(recipient: PromiseOrValue<string>, removeCollateral: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    sBorrowable(overrides?: CallOverrides): Promise<string>;
    safetyMarginSqrt(overrides?: CallOverrides): Promise<BigNumber>;
    setMaxPriceOffset(_maxPriceOffset: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setRebalanceThreshold(rebalanceThreshold_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setSafetyMarginSqrt(safetyMarginSqrt_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    short(overrides?: CallOverrides): Promise<string>;
    shortToUnderlyingOracle(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
    shortToUnderlyingOracleUpdate(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
    tarotBorrow(a: PromiseOrValue<string>, b: PromiseOrValue<string>, c: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    tarotRedeem(a: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    uBorrowable(overrides?: CallOverrides): Promise<string>;
    underlying(overrides?: CallOverrides): Promise<string>;
    updateOracle(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    vault(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<string>;
        GUARDIAN(overrides?: CallOverrides): Promise<string>;
        MANAGER(overrides?: CallOverrides): Promise<string>;
        _pair(overrides?: CallOverrides): Promise<string>;
        acceptOwnership(overrides?: CallOverrides): Promise<void>;
        accrueInterest(overrides?: CallOverrides): Promise<void>;
        callLoanHealth(overrides?: CallOverrides): Promise<BigNumber>;
        closePosition(arg0: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        collateralToken(overrides?: CallOverrides): Promise<string>;
        decimals(overrides?: CallOverrides): Promise<number>;
        deposit(underlyingAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        emergencyAction(actions: EActionStruct[], overrides?: CallOverrides): Promise<void>;
        farmRouter(overrides?: CallOverrides): Promise<string>;
        flip(overrides?: CallOverrides): Promise<boolean>;
        getAndUpdateTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getDepositAmnt(uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getExpectedPrice(overrides?: CallOverrides): Promise<BigNumber>;
        getLPBalances(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            underlyingLp: BigNumber;
            shortLp: BigNumber;
        }>;
        getLiquidity(overrides?: CallOverrides): Promise<BigNumber>;
        getLpBalance(overrides?: CallOverrides): Promise<BigNumber>;
        getLpToken(overrides?: CallOverrides): Promise<string>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getPositionOffset(overrides?: CallOverrides): Promise<BigNumber>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
        getTVL(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber,
            BigNumber
        ] & {
            tvl: BigNumber;
            borrowPosition: BigNumber;
            borrowBalance: BigNumber;
            lpBalance: BigNumber;
            underlyingBalance: BigNumber;
        }>;
        getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        getWithdrawAmnt(lpTokens: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        harvest(harvestParams: HarvestSwapParamsStruct[], arg1: HarvestSwapParamsStruct[], overrides?: CallOverrides): Promise<[BigNumber[], BigNumber[]] & {
            farmHarvest: BigNumber[];
        }>;
        harvestIsEnabled(overrides?: CallOverrides): Promise<boolean>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<boolean>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        impermaxChef(overrides?: CallOverrides): Promise<string>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
        maxPriceOffset(overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<string>;
        pair(overrides?: CallOverrides): Promise<string>;
        pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
        pendingOwner(overrides?: CallOverrides): Promise<string>;
        rebalance(expectedPrice: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        rebalanceThreshold(overrides?: CallOverrides): Promise<number>;
        redeem(recipient: PromiseOrValue<string>, removeCollateral: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        sBorrowable(overrides?: CallOverrides): Promise<string>;
        safetyMarginSqrt(overrides?: CallOverrides): Promise<BigNumber>;
        setMaxPriceOffset(_maxPriceOffset: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setRebalanceThreshold(rebalanceThreshold_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        setSafetyMarginSqrt(safetyMarginSqrt_: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        short(overrides?: CallOverrides): Promise<string>;
        shortToUnderlyingOracle(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        shortToUnderlyingOracleUpdate(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<boolean>;
        tarotBorrow(a: PromiseOrValue<string>, b: PromiseOrValue<string>, c: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        tarotRedeem(a: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<void>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
        uBorrowable(overrides?: CallOverrides): Promise<string>;
        underlying(overrides?: CallOverrides): Promise<string>;
        updateOracle(overrides?: CallOverrides): Promise<void>;
        vault(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "Deposit(address,uint256)"(sender?: null, amount?: null): DepositEventFilter;
        Deposit(sender?: null, amount?: null): DepositEventFilter;
        "EmergencyAction(address,bytes)"(target?: PromiseOrValue<string> | null, data?: null): EmergencyActionEventFilter;
        EmergencyAction(target?: PromiseOrValue<string> | null, data?: null): EmergencyActionEventFilter;
        "Harvest(uint256)"(harvested?: null): HarvestEventFilter;
        Harvest(harvested?: null): HarvestEventFilter;
        "HarvestedToken(address,uint256)"(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        "OwnershipTransferInitiated(address,address)"(owner?: null, pendingOwner?: null): OwnershipTransferInitiatedEventFilter;
        OwnershipTransferInitiated(owner?: null, pendingOwner?: null): OwnershipTransferInitiatedEventFilter;
        "OwnershipTransferred(address,address)"(oldOwner?: null, newOwner?: null): OwnershipTransferredEventFilter;
        OwnershipTransferred(oldOwner?: null, newOwner?: null): OwnershipTransferredEventFilter;
        "Rebalance(uint256,uint256,uint256)"(shortPrice?: null, tvlBeforeRebalance?: null, positionOffset?: null): RebalanceEventFilter;
        Rebalance(shortPrice?: null, tvlBeforeRebalance?: null, positionOffset?: null): RebalanceEventFilter;
        "Redeem(address,uint256)"(sender?: null, amount?: null): RedeemEventFilter;
        Redeem(sender?: null, amount?: null): RedeemEventFilter;
        "RoleAdminChanged(bytes32,bytes32,bytes32)"(role?: PromiseOrValue<BytesLike> | null, previousAdminRole?: PromiseOrValue<BytesLike> | null, newAdminRole?: PromiseOrValue<BytesLike> | null): RoleAdminChangedEventFilter;
        RoleAdminChanged(role?: PromiseOrValue<BytesLike> | null, previousAdminRole?: PromiseOrValue<BytesLike> | null, newAdminRole?: PromiseOrValue<BytesLike> | null): RoleAdminChangedEventFilter;
        "RoleGranted(bytes32,address,address)"(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleGrantedEventFilter;
        RoleGranted(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleGrantedEventFilter;
        "RoleRevoked(bytes32,address,address)"(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleRevokedEventFilter;
        RoleRevoked(role?: PromiseOrValue<BytesLike> | null, account?: PromiseOrValue<string> | null, sender?: PromiseOrValue<string> | null): RoleRevokedEventFilter;
        "SetMaxPriceOffset(uint256)"(maxPriceOffset?: null): SetMaxPriceOffsetEventFilter;
        SetMaxPriceOffset(maxPriceOffset?: null): SetMaxPriceOffsetEventFilter;
        "SetRebalanceThreshold(uint256)"(rebalanceThreshold?: null): SetRebalanceThresholdEventFilter;
        SetRebalanceThreshold(rebalanceThreshold?: null): SetRebalanceThresholdEventFilter;
        "SetSafetyMarginSqrt(uint256)"(safetyMarginSqrt?: null): SetSafetyMarginSqrtEventFilter;
        SetSafetyMarginSqrt(safetyMarginSqrt?: null): SetSafetyMarginSqrtEventFilter;
    };
    estimateGas: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<BigNumber>;
        GUARDIAN(overrides?: CallOverrides): Promise<BigNumber>;
        MANAGER(overrides?: CallOverrides): Promise<BigNumber>;
        _pair(overrides?: CallOverrides): Promise<BigNumber>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        callLoanHealth(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        closePosition(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<BigNumber>;
        collateralToken(overrides?: CallOverrides): Promise<BigNumber>;
        decimals(overrides?: CallOverrides): Promise<BigNumber>;
        deposit(underlyingAmnt: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        emergencyAction(actions: EActionStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        farmRouter(overrides?: CallOverrides): Promise<BigNumber>;
        flip(overrides?: CallOverrides): Promise<BigNumber>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        getDepositAmnt(uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        getExpectedPrice(overrides?: CallOverrides): Promise<BigNumber>;
        getLPBalances(overrides?: CallOverrides): Promise<BigNumber>;
        getLiquidity(overrides?: CallOverrides): Promise<BigNumber>;
        getLpBalance(overrides?: CallOverrides): Promise<BigNumber>;
        getLpToken(overrides?: CallOverrides): Promise<BigNumber>;
        getMaxTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getPositionOffset(overrides?: CallOverrides): Promise<BigNumber>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
        getTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getTotalTVL(overrides?: CallOverrides): Promise<BigNumber>;
        getTvl(overrides?: CallOverrides): Promise<BigNumber>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<BigNumber>;
        getWithdrawAmnt(lpTokens: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        harvest(harvestParams: HarvestSwapParamsStruct[], arg1: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        harvestIsEnabled(overrides?: CallOverrides): Promise<BigNumber>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<BigNumber>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        impermaxChef(overrides?: CallOverrides): Promise<BigNumber>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        loanHealth(overrides?: CallOverrides): Promise<BigNumber>;
        maxPriceOffset(overrides?: CallOverrides): Promise<BigNumber>;
        owner(overrides?: CallOverrides): Promise<BigNumber>;
        pair(overrides?: CallOverrides): Promise<BigNumber>;
        pendingHarvest(overrides?: CallOverrides): Promise<BigNumber>;
        pendingOwner(overrides?: CallOverrides): Promise<BigNumber>;
        rebalance(expectedPrice: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        rebalanceThreshold(overrides?: CallOverrides): Promise<BigNumber>;
        redeem(recipient: PromiseOrValue<string>, removeCollateral: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        sBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        safetyMarginSqrt(overrides?: CallOverrides): Promise<BigNumber>;
        setMaxPriceOffset(_maxPriceOffset: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setRebalanceThreshold(rebalanceThreshold_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setSafetyMarginSqrt(safetyMarginSqrt_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<BigNumber>;
        shortToUnderlyingOracle(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<BigNumber>;
        shortToUnderlyingOracleUpdate(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<BigNumber>;
        tarotBorrow(a: PromiseOrValue<string>, b: PromiseOrValue<string>, c: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        tarotRedeem(a: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        uBorrowable(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
        updateOracle(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        vault(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        DEFAULT_ADMIN_ROLE(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        GUARDIAN(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        MANAGER(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        _pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        acceptOwnership(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        accrueInterest(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        callLoanHealth(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        closePosition(arg0: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        collateralToUnderlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        collateralToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        decimals(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        deposit(underlyingAmnt: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        emergencyAction(actions: EActionStruct[], overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        farmRouter(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        flip(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getAndUpdateTvl(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        getDepositAmnt(uAmnt: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getExpectedPrice(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLPBalances(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLiquidity(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLpBalance(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getLpToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getMaxTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getPositionOffset(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getRoleAdmin(role: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTVL(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTotalTVL(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getTvl(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getWithdrawAmnt(lpTokens: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        grantRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        harvest(harvestParams: HarvestSwapParamsStruct[], arg1: HarvestSwapParamsStruct[], overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        harvestIsEnabled(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        hasRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        impermaxBorrow(arg0: PromiseOrValue<string>, arg1: PromiseOrValue<string>, arg2: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        impermaxChef(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        impermaxRedeem(arg0: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        loanHealth(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        maxPriceOffset(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        owner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingHarvest(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        pendingOwner(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        rebalance(expectedPrice: PromiseOrValue<BigNumberish>, maxDelta: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        rebalanceThreshold(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        redeem(recipient: PromiseOrValue<string>, removeCollateral: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        renounceRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        revokeRole(role: PromiseOrValue<BytesLike>, account: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        sBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        safetyMarginSqrt(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        setMaxPriceOffset(_maxPriceOffset: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setRebalanceThreshold(rebalanceThreshold_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setSafetyMarginSqrt(safetyMarginSqrt_: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        short(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        shortToUnderlyingOracle(amount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        shortToUnderlyingOracleUpdate(amount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        supportsInterface(interfaceId: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        tarotBorrow(a: PromiseOrValue<string>, b: PromiseOrValue<string>, c: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        tarotRedeem(a: PromiseOrValue<string>, redeemAmount: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        transferOwnership(_pendingOwner: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        uBorrowable(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        updateOracle(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        vault(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
